/**
 * ݂݂Ȃɂg
 * GPL2 ɏ]Ă
 */
#include <windows.h>
#include <shlwapi.h>
#include <stdio.h>
#include "arc.h"
#define M_ERROR_MESSAGE_OFF		0x00800000L

#include "ulunzip.h"
#include "settings.h"

extern int MystrCmp(char *,char *);


BOOL Uncompress( HWND hwnd, char **ptrlpBuf, LPCSTR ArcName, LPDWORD lpdwSize )
{
	const char *szLibNames[] = {
		"Unlha32",
		"UnZip32",
		"Unrar32",
		"Cab32",
		"Tar32",
		"Unarj32j",
		"Bga32"
	};

	const char *szFuncNamePreFixes[] = {
		"Unlha",
		"UnZip",
		"Unrar",
		"Cab",
		"Tar",
		"Unarj",
		"Bga"
	};

	const char *szCommands[] = {
		NULL,
		NULL,
		"-e -u \"%s\" \"%s\" \"%s\"",
		"-x -j \"%s\" \"%s\" \"%s\"",
		"-x -f \"%s\" -o \"%s\" \"%s\"",
		"e \"%s\" \"%s\" \"%s\"",
		"x -n \"%s\" \"%s\" \"%s\""
	};

	const char *ArcExtstr[] = {
		"lzh",
		"zip",
		"rar",
		"cab",
		"tar",
		"arj",
		"bga"
	};

#define LIB_UNLHA	0
#define LIB_UNZIP	1
#define LIB_UNRAR	2
#define LIB_CAB		3
#define LIB_TAR		4
#define LIB_UNARJ	5
#define LIB_BGA		6


	const char *szExtensions[] = {
		"*.nes",
		"*.fds",
		"*.fam",
		"*.nsf"
	};

	int i,j,result;
	HMODULE hLib;
	HANDLE hf;
	HARC harc = NULL;
	char szFuncName[256], *extp, flag;
	char szCommand[256];
	char szTempPath[512];
	char szTempFullName[512];
	EXECUTECOMMAND ExecuteCommand;
//	CHECKARCHIVE CheckArchive;
	EXTRACTMEM ExtractMem;
	OPENARCHIVE OpenArchive;
	CLOSEARCHIVE CloseArchive;
	FINDFIRST FindFirst;
	INDIVIDUALINFO idvinfo;
	GetTempPath( MAX_PATH + 1, szTempPath );

	extp=PathFindExtension(ArcName);
	++extp;
	for(i=0,flag=0; i<7; ++i){
		if(MystrCmp(extp, (char *)ArcExtstr[i])){
			flag=1;
			break;
		}
	}
	if(!flag)
		return FALSE;
	if(i==1 && !NESTER_settings.nes.preferences.ZipDLLUseFlag){
		if(UseUnzipLibExeLoad((char *)ArcName, (unsigned char **)(ptrlpBuf), lpdwSize))
			return TRUE;
//		else
//			return FALSE;
	}

//	for( i=0; i<7; i++ )
	{
		if(!(hLib = LoadLibrary(szLibNames[i])))
			return FALSE;
/*		sprintf( szFuncName, "%sCheckArchive", szFuncNamePreFixes[i] );
		if( !(CheckArchive = (CHECKARCHIVE)GetProcAddress( hLib, szFuncName ) ) )
			return FALSE;
		if( !CheckArchive( ArcName, 1 ) )
			return FALSE;
*/
		sprintf( szFuncName, "%sOpenArchive", szFuncNamePreFixes[i] );
		OpenArchive = (OPENARCHIVE)GetProcAddress( hLib, szFuncName );

		sprintf( szFuncName, "%sFindFirst", szFuncNamePreFixes[i] );
		FindFirst = (FINDFIRST)GetProcAddress( hLib, szFuncName );

		sprintf( szFuncName, "%sCloseArchive", szFuncNamePreFixes[i] );
		CloseArchive = (CLOSEARCHIVE)GetProcAddress( hLib, szFuncName );

		result = -1;
		for( j=0; j<4; j++ )
		{
			if( !(harc = OpenArchive( hwnd, ArcName, M_ERROR_MESSAGE_OFF ) ) )
			{	
				CloseArchive( harc );
				break;
			}
			result = FindFirst( harc, szExtensions[j], &idvinfo );
			CloseArchive( harc );
			if( result == 0 )
				break;
		}
		
		if( result )
			return FALSE;

		if( szCommands[i] )
		{
			sprintf( szCommand, szCommands[i],
				ArcName, szTempPath, idvinfo.szFileName );
			ExecuteCommand = (EXECUTECOMMAND)GetProcAddress( hLib, szFuncNamePreFixes[i] );
			ExecuteCommand( hwnd, szCommand, NULL, 0 );
			
			sprintf( szTempFullName, "%s%s", szTempPath, idvinfo.szFileName );
			hf = CreateFile(
				szTempFullName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING,
				FILE_FLAG_SEQUENTIAL_SCAN, NULL );
			if( hf == INVALID_HANDLE_VALUE )
				throw "t@C̓ǂݍ݂Ɏs܂";
			*lpdwSize = GetFileSize( hf, NULL );
			*ptrlpBuf = (char*)malloc(*lpdwSize);
			DWORD rsize;
			ReadFile( hf, *ptrlpBuf, *lpdwSize, &rsize, NULL );
			CloseHandle( hf );
			DeleteFile( szTempFullName );
			if( *lpdwSize != rsize )
				throw "t@C̓ǂݍ݂Ɏs܂";
			return TRUE;
		}
		else
		{
			char sz[FNAME_MAX32 + 1];
			if( i == LIB_UNZIP )
			{
				int p1=0, p2=0;
				while(true)
				{
					if( IsDBCSLeadByte( idvinfo.szFileName[p1] ) )
					{
						sz[p2++] = idvinfo.szFileName[p1++];
					}
					else switch( idvinfo.szFileName[p1] )
					{
					case '[':case ']':
						sz[p2++] = '\\';
					}
					if( !( sz[p2++] = idvinfo.szFileName[p1++] ) )
						break;
				}
			}
			else
				strcpy( sz, idvinfo.szFileName );
			*lpdwSize = idvinfo.dwOriginalSize;
			*ptrlpBuf = (char*)malloc(*lpdwSize);
			sprintf( szCommand, "\"%s\" \"%s\"", ArcName, sz );
			sprintf( szFuncName, "%sExtractMem", szFuncNamePreFixes[i] );
			ExtractMem = (EXTRACTMEM)GetProcAddress( hLib, szFuncName );
			result = ExtractMem(
						hwnd, szCommand, (LPBYTE)(*ptrlpBuf), *lpdwSize,
						NULL, NULL, NULL ); 
			if( result == 0 )
				return TRUE;
		}

	}
	return FALSE;
}
